# Contributing
You can contribute to this project by simply adding or fixing data in
[countries.json](https://github.com/mledoze/countries/blob/master/countries.json). Before sending your pull request you
can optionally rebuild the files in the `dist` folder using the
[countries.php](https://github.com/mledoze/countries/blob/master/countries.php) script.

# Contributions rules
1. contributions should contains **top-level**, **static** data.
2. restrain from sending too detailed, regional or changing countries data like the list of cities or financial data.
3. to ease the diffs, keep the indentation in the master source file (tabs not spaces), one line for short arrays
4. accented characters must be encoded in unicode
5. all strings must be encoded in UTF-8

# Adding a build script
Countries data is made available in multiple formats (JSON, CSV, XML) that are generated by the
[countries.php](https://github.com/mledoze/countries/blob/master/countries.php) script; you can either add a conversion
format to it or write it in another language.